#ifndef _COMPILER_H_
#define _COMPILER_H_

#ifdef __IMAGECRAFT__

#include <macros.h>
#include <eeprom.h>

#ifndef CONST
#define CONST
#endif

#ifndef INLINE
#define INLINE
#endif

#define __bss_end   _bss_end

#define __attribute__(x)  

#define PSTR(p)     (p)
#define PRG_RDB(p)  (*p)

#define prog_char const char

#define memcpy_P(dst, src, size)    \
{                                   \
    u_short _i;                     \
    u_char *d = dst;                \
    const u_char *s = src;          \
    for(_i = 0; _i < size; _i++)    \
        *d++ = *s++ ;               \
}

/* FIXME */
#define strcasecmp(s1, s2)  strcmp(s1, s2)
/* FIXME */
#define strncasecmp(s1, s2, n)  strncmp(s1, s2, n)

#define BV(x)       BIT(x)

#define cli()           CLI()
#define sei()           SEI()
#define cbi(reg, bit)   (reg &= ~BIT(bit))
#define sbi(reg, bit)   (reg |= BIT(bit))


#define loop_until_bit_is_set(reg, bit) while((reg & BIT(bit)) == 0)

#define bit_is_clear(reg, bit)  ((reg & BIT(bit)) == 0)
#define bit_is_set(reg, bit)    ((reg & BIT(bit)) != 0)

/* FIXME */
#define parity_even_bit(x)  (0)

/* FIXME */
#define SIGNAL(x)   void x(void)  

#define outp(val, reg)  (reg = val)
#define inp(reg)        (reg)

#ifndef __AVR_ATmega128__
#include <iom103.h>
#else
#include <iom128.h>

//*KU* to be compatible with the  old files for 
// ATMEGA 103
#define		USR 		UCSR0A
#define		UCR		UCSR0B
#define		UDR 		UDR0
#define		SRW		SRW10


/*KU* UART Status Register */
#define		RXC	RXC0
#define		TXC     TXC0
#define		UDRE    UDRE0
#define		FE      FE0
#define		OVR     DOR0
#define		UBRR	UBRR0L

/*KU* UART Status Control Register */
#define		RXCIE        RXCIE0
#define		TXCIE        TXCIE0
#define		UDRIE        UDRIE0
#define		RXEN         RXEN0
#define		TXEN         TXEN0
#define		CHR9         UCSZ02
#define		RXB8         RXB80
#define		TXB8         TXB80

//*KU* Constants
#define    RAMEND   0x0FFF    //Last On-Chip SRAM Location
#define    XRAMEND  0xFFFF
#define    E2END    0x0FFF
#define    FLASHEND 0x1FFFF

#endif

//#define eeprom_read_block(dst, addr, size)  EEPROMReadBytes(addr, (void *)dst, size)
//#define eeprom_wb(addr, src)                EEPROMWriteBytes(addr, (void *)src, 1)

#define eeprom_read_block(dst, addr, size)  EEPROMReadBytes(addr, dst, size)
#define eeprom_wb(addr, src)                EEPROMWriteBytes(addr, &src, 1)


#else   /* GCC -------------------------------------------------------------- */

#define CONST   const
#define INLINE  inline

#ifdef USE_LOW_LEVEL
#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#endif

#ifndef __SFR_OFFSET
#define __SFR_OFFSET    0
#endif

#endif  /* !GCC */



extern void * __bss_end;

#ifdef __AVR_ATmega128__
#define RAMSTART    ((void *)0x100)
#else
#define RAMSTART    ((void *)0x60)
#endif

#endif

